function [adj_mat coords] = f_gen_wireless_graph(num_of_nodes,squaresize,connthr);

%______________________________________________________________
% Generate positions (coords)

s2=squaresize/2;
jj=0;
while jj<num_of_nodes,
     jj=jj+1;
     coords(jj,1)=s2*(2*rand-1);
     coords(jj,2)=s2*(2*rand-1);
end

%______________________________________________________________
% Calculate connections  (adj_mat)


edges(num_of_nodes,num_of_nodes)=0;
for ii=1:num_of_nodes,
  for jj=(ii+1):num_of_nodes,
    if abs(coords(ii,1)+i*coords(ii,2)-coords(jj,1)-i*coords(jj,2))<=connthr,
       adj_mat(ii,jj)=1;   adj_mat(jj,ii)=1;
    else                 
       adj_mat(ii,jj)=0;   adj_mat(jj,ii)=0;
    end
  end
end

