clear all; close all; clear classes;
%format long;

%unit circle; x y axes
figure; hold on;
th = (0:512)/1024*2*pi; x = cos(th); y = sin(th); plot(x,y);
plot([0,0],[0,1.2]); plot([-1.2,1.2],[0,0]);

A=[-1 0;0 1];
B=[1+2i,1;1,1-2i];
v=-i*(2-sqrt(3));
msize1=7;
lwidth=1;

levelfin=5;

M{1}=A;
plot(J(M{1},v),'.k','MarkerSize',msize1);
for level=1:levelfin,
 for k=1:2:(2^level-1),
   k1=floor((k+1)/2);
   M2{k}=B*A*M{k1};
   M2{k+1}=B*M2{k};
   node1=J(M2{k},v);
   node2=J(M2{k+1},v);
   plot(node1,'.k','MarkerSize',msize1);
   plot(node2,'.k','MarkerSize',msize1);
   %plot([J(M{k1},v),node1],'-k','linewidth',lwidth);
   %plot([J(M{k1},v),node2],'-k','linewidth',lwidth);


   %plot hyperbolic edge between newparent and newchild
     xa=real(J(M{k1},v))+1.1e-8; 
     ya=imag(J(M{k1},v))+1e-8;
     xb=real(node1); 
     yb=imag(node1);
     aa=-(xb-xa)/(yb-ya); bb=(xa^2-xb^2+(ya-yb)*(ya+yb))/(2*(ya-yb));
     %geodesic circle center and radius
       xc=(xa^2*yb-xb^2*ya+(ya-yb)*(ya*yb-1))/(2*(xa*yb-xb*ya));  yc=aa*xc+bb;  R=sqrt((yc-ya)^2+(xc-xa)^2);
     a1=angle(J(M{k1},v)-xc-i*yc);  a2=angle(node1-xc-i*yc);
     if xc>0,
       if (a1>0) & (a2<0),
         a2=a2+2*pi;
       elseif (a1<0) & (a2>0),
         a1=a1+2*pi;
       end
       step=abs(a1-a2)/500; theta = min(a1,a2):step:max(a1,a2);
     else
       step=-abs(a1-a2)/500; theta = max(a1,a2):step:min(a1,a2);
     end
     xuc = R*cos(theta)+xc; yuc = R*sin(theta)+yc;  plot(xuc,yuc,'-k','linewidth',0.8);


   %plot hyperbolic edge between newparent and newchild
     xa=real(J(M{k1},v))+1.1e-8; 
     ya=imag(J(M{k1},v))+1e-8;
     xb=real(node2); 
     yb=imag(node2);
     aa=-(xb-xa)/(yb-ya); bb=(xa^2-xb^2+(ya-yb)*(ya+yb))/(2*(ya-yb));
     %geodesic circle center and radius
       xc=(xa^2*yb-xb^2*ya+(ya-yb)*(ya*yb-1))/(2*(xa*yb-xb*ya));  yc=aa*xc+bb;  R=sqrt((yc-ya)^2+(xc-xa)^2);
     a1=angle(J(M{k1},v)-xc-i*yc);  a2=angle(node2-xc-i*yc);
     if xc>0,
       if (a1>0) & (a2<0),
         a2=a2+2*pi;
       elseif (a1<0) & (a2>0),
         a1=a1+2*pi;
       end
       step=abs(a1-a2)/500; theta = min(a1,a2):step:max(a1,a2);
     else
       step=-abs(a1-a2)/500; theta = max(a1,a2):step:min(a1,a2);
     end
     xuc = R*cos(theta)+xc; yuc = R*sin(theta)+yc;  plot(xuc,yuc,'-k','linewidth',0.8);






 end
 M=M2;
 clear M2;
end


axis([-1.2 1.2 0 1.2]);axis equal; %axis square;
axis off;



